-- Public Domain software.
-- Euphoria 2.5 -- unlimited alphabet bilingual interpreter.
-- Any code page for the names.
-- English and Russian keywords, builtins, standard routines.
-- English  or Russian interpreter messages.
-- A Euphoria Interpreter written 100% in Euphoria by RDS,
-- bilingual reconstruction by Igor N. Kachan, 2005 May.
-- Report the problems to  kinz@peterlink.ru
--
-- usage:
--        ex eu_ru.ex prog.ex     -- run a Euphoria program for DOS
--        exw eu_ru.ex prog.exw   -- run a Euphoria program for Windows
--        exu eu_ru.ex prog.exu   -- run a Euphoria program for Linux/FreeBSD
-- To run it in Linux/FreeBSD, you must recode some files into koi8-r CP

-- You can make this into a stand-alone .exe using the binder or the
-- Euphoria To C Translator. When translated/compiled it will run
-- much faster, but not as fast as the official RDS interpreter
-- which uses the same Euphoria-coded front-end, combined 
-- with a high-performance back-end carefully hand-coded in C.

without type_check

global constant INTERPRETER_VERSION = "2.5"

integer fn
global integer LANG
 LANG = 0
 
   fn = open("language.er", "rb")
   if fn > -1 then
 LANG = getc(fn)
       close(fn) end if
       
    if LANG = 'e' -- English language of the interpreter messages
  then LANG =  1
 elsif LANG = 'r' -- Russian language of the interpreter messages
  then LANG =  2
  else LANG =  1
end if

global constant messages = {  -- compiler/executor error/warning messages
{"Bilingual Euphoria Interpreter " & INTERPRETER_VERSION & " ",     --001
 "  Euphoria " & INTERPRETER_VERSION & " "}, --001
{"for Linux/FreeBSD.\n",  --002
 " Linux/FreeBSD.\n"}, --002
{"for FreeBSD.\n",  --003
 " FreeBSD.\n"}, --003
{"for Linux.\n",  --004
 " Linux.\n"}, --004
{"for DOS/Windows.\n",  --005
 " DOS/Windows.\n"}, --005
{"for 32-bit Windows.\n",        --006
 " 32-ࠧ來 Windows.\n"}, --006
{"for 32-bit DOS.\n",        --007
 " 32-ࠧ來 DOS.\n"}, --007
{"Source code provided by Rapid Deployment Software is changed.\n", --008
 "⠭ , ।⠢ RDS, ࠡ⠭.\n"},           --008
{"http://www.RapidEuphoria.com \n",                                    --009
 "RDS   ⢥⢥   ਬ  襩 設.\n"}, --009
{"Rapid Deployment Software is not responsible for any damage. \n",   --010
 "RDS - Rapid Deployment Software - http://www.RapidEuphoria.com \n"},--010
{"\nfile name to execute? ",  --011
 "\n 䠩 ᯮ? "}, --011
{"DOS32 built for DJGPP", --012
 "DOS32 ᡮઠ  DJGPP"}, --012
{"DOS32",              --013
 "DOS32 ᡮઠ  OW"}, --013
{"WIN32",             --014
 "WIN32 ᡮઠ  OW"},--014
{"Linux",               --015
 "Linux ᡮઠ  GCC"}, --015
{"Too many warnings - no more will be issued",       --016
 "誮  ।० - 뢮 ⠭"}, --016
{"Warning: %s\n",   --017
 ": %s\n"}, --017
{"\nPress Enter\n",    --018
 "\n Enter\n"}, --018
{"Can't create error message file: ",           --019
 "  ᮧ 䠩 ᮮ饭  訡: "}, --019
{"<end-of-file>\n",  --020
 "<-䠩>\n"}, --020
{"%s is not supported in Euphoria for %s",  --021
 "%s  ࠡ⠥  Euphoria  %s"},       --021
{"Internal Error: %s\n",     --022
 "७ 訡: %s\n"}, --022
{"Internal Error at %s:%d - %s\n",     --023
 "७ 訡  %s:%d - %s\n"}, --023
{"attempt to redefine %s",      --024
 "⪠ ८। %s"}, --024
{"local constant",     --025
 "⭠ ⠭"}, --025
{"local variable",       --026
 "⭠ ६"},  --026
{"parameter", --027
 "㬥"}, --027
{"private variable",    --028
 "⭠ ६"}, --028
{"not used",         --029
 " ᯮ"}, --029
{"never assigned a value", --030
 "  稭"},     --030
{"%s %s in %s() in %s is %s", --031
 "%s %s  %s()  %s - %s"},   --031
{"%s %s in %s is %s",--032
 "%s %s  %s - %s"}, --032
{"illegal character (ASCII 0)",                    --033
 "⨬ ᨬ  室  (ASCII 0)"}, --033
{"can't open %s",       --034
 "   %s"}, --034
{"can't find %s in %s\nor in %s%sinclude",       --035
 "   %s   %s,\n  %s%sinclude"}, --035
{"can't find %s in %s\nor in %s\nor in %s%sinclude",       --036
 "   %s   %s,\n  %s,\n  %s%sinclude"}, --036
{"includes are nested too deeply",                      --037
 "㡨  ⥪ ॢᨫ ⨬"}, --037
{"program includes too many files",             --038
 "ணࠬ 砥 ᫨誮  ⥪"}, --038
{"unknown escape character",         --039
 "⨬ ࠢ騩 ᨬ"}, --039
{"number not formed correctly", --040
 "᫮ ᠭ ୮"},     --040
{"an identifier is expected here",  --041
 "  "},            --041
{"only one decimal point allowed",         --042
 "⨬ ⮫쪮  筠 窠"},--042
{"fractional part of number is missing", --043
 " ஡  ᫠"},     --043
{"exponent not formed correctly",          --044
 "ୠ ᯮ樠쭠 ଠ ᫠"}, --044
{"tab character found in string - use \\t instead",               --045
 " ப   ⠡樨 - ᯮ \\t,   "},--045
{"end of line reached with no closing \"", --046
 "ப   窮 \""}, --046
{"#! may only be on the first line of a program", --047
 "#! ࠧ襭 ⮫쪮  ࢮ ப ணࠬ"},--047
{"hex number not formed correctly",          --048
 "⭠筮 ᫮ ᠭ ୮"},--048
{"single-quote character is empty",              --049
 "  祪   ⮩"}, --049
{"character constant is missing a closing '",             --050
 " ᨬ쭮 ⮬   뢠 窠 '"},--050
{"Scanner()",            --051
 "楤 Scanner()"}, --051
{"missing closing quote on file name",             --052
 "  䠩   뢠 窠"}, --052
{"file name is missing",          --053
 "    䠩"}, --053
{"a new namespace identifier is expected here", --054
 "   䨪  "}, --054
{"missing namespace qualifier",            --055
 "   䨪  "},--055
{"improper syntax for include-as",           --056
 "୮ ᠭ  include-as"}, --056
{"unknown opcode: %d",             --057
 "⨬  樨: %d"}, --057
{"%s:%d - statement after %s will never be executed",    --058
 "%s:%d -  ᫥ %s   㤥 믮"}, --058
{"Syntax error - expected to see possibly %s, not %s", --059
 ", , ॡ  %s,   %s"},       --059
{"%s has not been declared",      --060
 " %s   "}, --060
{"A namespace qualifier is needed to resolve %s.\n%s is defined as a global symbol in:\n", --061
 " 㦥 䨪    %s.\n %s   쭮 :\n"},        --061
{"%s takes %s%d argument%s",    --062
 "%s ॡ %s%d 㬥%s"}, --062
{"only ",    --063
 "⮫쪮 "}, --063
{"'$' must only appear between '[' and ']'",--064
 "'$'   ⮫쪮  '['  ']'"},  --064
{"%.99s:%d - call to %s() might be short-circuited",          --065
 "%.99s:%d -  맮 %s()  㪮祭 楤"}, --065
{"Syntax error - expected to see an expression, not %s",--066
 "  ࠦ,   %s"},                 --066
{"may not assign to a for-loop variable",                 --067
 "६ 横 for  ⮫쪮 ⮬᪨"}, --067
{"may not change the value of a constant",              --068
 "ࠧ  稭 ⠭  "},--068
{"Syntax error - expected to see =, +=, -=, *=, /= or &=",--069
 "  =, +=, -=, *=, /=  &="},             --069
{"return must be inside a procedure or function",           --070
 " return-뤠    ணࠬ"}, --070
{"exit statement must be inside a loop",          --071
 " exit-    横"}, --071
{"SetPS",                  --072
 "SetPS - ⭠ 業"}, --072
{"a loop variable name is expected here", --073
 "   ६ 横"}, --073
{"a name is expected here",  --074
 "  "},     --074
{"a variable name is expected here", --075
 "   ६"},  --075
{"built-in routine %s() redefined",              --076
 "८। ஥ ணࠬ %s()"}, --076
{"a type is expected here", --077
 "  ⨯"},    --077
{"a parameter name is expected here", --078
 "   㬥"},    --078
{"expected to see a parameter declaration, not ')'",  --079
 " । 㬥,   ')'"},        --079
{"badly-formed list of parameters - expected ',' or ')'",     --080
 "ୠ ଠ ᯨ᪠ 㬥⮢ -  ','  ')'"}, --080
{"types must have exactly one parameter",   --081
 "⨯   ⢥ 㬥"}, --081
{"no value returned from function",   --082
 "㭪  뤠 稭"}, --082
{"type must return true / false value",       --083
 "⨯  뤠 稭 ⨭/"}, --083
{"sample size must be a positive integer",          --084
 "ࠧ 롮ન   ⥫ 楫"}, --084
{"unknown with/without option",     --085
 "⠪ ० with/without "}, --085
{"'global' must be followed by:\n"&
 "    <a type>, 'constant', 'procedure', 'type' or 'function'",     --086
 " 'global-'  ᫥:\n"&
 "'constant-ᥣ', 'procedure-楤',\n"&
 "'type-⨯', 'function-㭪'  < 짮⥫᪮ ⨯>"},--086
{"function result must be assigned or used",                   --087
 "१ 㭪樨  ᢠ  ᯮ짮"}, --087
{"exit must be inside a loop",                    --088
 " exit-    横"}, --088
{"illegal character",                         --089
 " ᨬ  室  ᫮ ⨬"}, --089
{"unknown command",            --090
 "⠪   몥 "}, --090
{"Can't open %s\n",       --091
 "   %s\n"}, --091
{"\nPress Enter\n",    --092  
 "\n Enter\n"}, --092
{"",  --093 --- reserved section
 ""}, --093
{"",  --094
 ""}, --094
{"",  --095
 ""}, --095
{"",  --096
 ""}, --096
{"",  --097
 ""}, --097
{"",  --098
 ""}, --098
{"",  --099
 ""}, --099
{"",  --100
 ""}, --100
{"",  --101
 ""}, --101
{"",  --102
 ""}, --102
{"",  --103
 ""}, --103
{"",  --104
 ""}, --104
{"",  --105
 ""}, --105
{"",  --106
 ""}, --106
{"",  --107
 ""}, --107
{"",  --108
 ""}, --108
{"",  --109
 ""}, --109
{"",  --110
 ""}, --110
{"",  --111
 ""}, --111
{"",  --112
 ""}, --112
{"",  --113
 ""}, --113
{"",  --114
 ""}, --114
{"",  --115
 ""}, --115
{"",  --116
 ""}, --116
{"",  --117
 ""}, --117
{"",  --118
 ""}, --118
{"",  --119
 ""}, --119
{"",  --120
 ""}, --120
{"",  --121
 ""}, --121
{"",  --122
 ""}, --122
{"",  --123
 ""}, --123
------------------------------backend written in Euphoria
{"Can't open ",       --124
 "   "}, --124
{"<no value>",     --125
 "< 稭>"},--125
{"... called from ",--126
 "... 맮  "},  --126
{"^^^ called to handle run-time crash\n",          --127
 "^^^ 맮  ࠡ⪨ ਩ ⠭\n"}, --127
{"^^^ call-back from ",     --128
 "^^^  맮  "}, --128
{"Windows\n",  --129
 "Windows\n"}, --129
{"external program\n",   --130
 "譥 ணࠬ\n"}, --130
{"in procedure ", --131
 " 楤 "}, --131
{"in function ",--132
 " 㭪樨 "}, --132
{"in type ", --133
 " ⨯ "}, --133
{"--> see ",     --134
 "--> ᬮ "}, --134
{"\n\nGlobal & Local Variables\n",         --135
 "\n\n   ६\n"}, --135
{"\nPress Enter...\n",    --136
 "\n Enter...\n"}, --136
{"type_check error\n%s is ",     --137
 "訡  ⨯\n%s -- "}, --137
{"Couldn't open ctrace.out",            --138
 " 㤠  䠩 ctrace.out"}, --138
{"=== THE END ===",  --139
 "===    ==="}, --139
{"attempt to exit a function without returning a value", --140
 "⪠ 室  㭪樨  뤠 १"},     --140
{"attempt to subscript an atom\n(reading from it)",  --141
 "⪠ ஢ ⮬\n(⥭  ⮬)"}, --141
{"subscript must be an atom\n(reading an element of a sequence)", --142
 "   ⮬\n(⥭  鸞)"},            --142
{"subscript value %d is out of bounds, reading from a sequence of length %d", --143
 "稭  %d  ࠭, ⥭  鸞  %d"},                  --143
{"not initialized",          --144
 "ॡ 樠"}, --144
{"length of an atom is not defined", --145
 "  ⮬  "},   --145
{"attempt to subscript an atom\n(assigning to it)",     --146
 "⪠ ஢ ⮬\n(ᢠ ⮬)"}, --146
{"subscript must be an atom\n(assigning to a sequence of length %d)",  --147
 "   ⮬\n(ᢠ  拉  %d)"},         --147
{"subscript value %d is out of bounds, assigning to a sequence of length %d",--148
 "稭  %d  ࠭, ᢠ  拉  %d"},            --148
{"slice lower index is not an atom",          --149
 "  祭   ⮬"}, --149
{"slice lower index is less than 1",               --150
 "  祭     1"}, --150
{"slice upper index is not an atom",           --151
 "孨  祭   ⮬"}, --151
{"slice upper index is less than 0",                --152
 "孨  祭     0"}, --152
{"slice length is less than 0",            --153
 " १     0"}, --153
{"lengths do not match on assignment to slice",                   --154
 "ᢠ 稭 १ -  冷  ᮢ"}, --154
{"attempt to slice an atom",  --155
 "⪠ 祭 ⮬"},    --155
{"slice starts past end of sequence",            --156
 "祭  稭   殬 鸞"}, --156
{"slice ends past end of sequence",                 --157
 "祭  稢   殬 鸞"}, --157
{"subscript must be an atom\n(assigning to subscript of a sequence)",   --158
 "   ⨯ ⮬\n(ᢠ 稭  鸞)"}, --158
{"attempt to divide by 0",       --159
 "⪠   0 ()"}, --159
{"Can't get remainder of a number divided by 0",  --160
 "⮪    0 ()  "}, --160
{"true/false condition must be an ATOM",   --161
 "᫮ ⨭/   "},--161
{"for-loop variable is not an atom",         --162
 "६ 横 for   ⮬"}, --162
{"for-loop limit is not an atom",        --163
 "। 横 for   ⮬"}, --163
{"for-loop increment is not an atom",        --164
 "饭 横 for   ⮬"}, --164
{"invalid routine id",           --165
 "  ணࠬ"}, --165
{"%s() does not return a value",            --166
 "㭪 %s()  뤠 १"}, --166
{"the value returned by %s() must be assigned or used",          --167
 "१ 㭪樨 %s()   ᢮  ᯮ짮"}, --167
{"argument list must be a sequence",        --168
 "ᯨ᮪ 㬥⮢   ⨯ "}, --168
{"call to %s() via routine-id should pass %d arguments, not %d",  --169
 "맮 %s()   ॡ %d 㬥⮢,   %d"},          --169
{"Invalid routine id",           --170
 "  ணࠬ"}, --170
{"crash routine requires a valid routine id",         --171
 " 맮 ਩ ணࠬ 㦥  "}, --171
{"",  --172 -- reserved section
 ""}, --172
{"",  --173
 ""}, --173
{"",  --174
 ""}, --174
{"",  --175
 ""}} --175
-------------------------------

global constant TRUE = 1, FALSE = 0

global constant INTERPRET = TRUE,
		TRANSLATE = FALSE,
		BIND = FALSE
		
global constant EXTRA_CHECK = FALSE 

-- standard Euphoria includes
include misc.e
include wildcard.e

-- INTERPRETER front-end
include global_r.e -- m, m stands for bilingual messages
include reswordr.e --
include error__r.e -- m
include keylistr.e --
include symtab_r.e -- m
include scannerr.e -- m
include emit___r.e -- m
include parser_r.e -- m

-- INTERPRETER back-end, written in Euphoria
include executer.e -- m
   
-- main program:
include main___r.e -- m

