-- Sort the elements of a sequence into ascending order, using "Shell" sort.
-- modified from the original in the U4 include folder.
--
-- Return the sorted sequence, and the indexes of the sorted sequence
--(i.e. their positions in the orginal non-sorted sequence)
--
-- Why bother?
-- This was needed in my forthcoming Eden V2 game, for unit formation and team pathing, where
-- the closest unit to a given point during a movement order becomes the leader. For this, I
-- required the indexes of the resulting sort so I could reference back to the original units.
--
-- Usage:
-- sequence result
-- result=index_sort({5,1,2,3})
--
-- That example would give you {{1,2,3,5},{2,3,4,1}}
-- The first part is the result of the sort
-- The second part is the index of the items
--
-- Pete King, Spectre Software, February 1999.
--
-- Http://come.to/spectre-soft
--
-- pete@theking29.freeserve.co.uk

global function index_sort(sequence x)
-- Sort a sequence into ascending order. The elements can be atoms or 
-- sequences. The standard compare() routine is used to compare elements.
-- This sort algorithym is modified from the standard, euphorian one, and differs in that it
-- returns the index of the elements of the sorted sequence as well as the sorted sequence.
    integer gap, j, first, last
    object tempi, tempj,temp_in1,temp_in2
    sequence index

    index={}
    for z=1 to length(x) do
       index&={z}
    end for

    last = length(x)
    gap = floor(last / 3) + 1
    while 1 do
	first = gap + 1
	for i = first to last do
	    tempi = x[i]
	    temp_in1=index[i]
	    j = i - gap
	    while 1 do
		tempj = x[j]
		temp_in2=index[j]

		if compare(tempi, tempj) >= 0 then
		    j += gap
		    exit
		end if
		x[j+gap] = tempj
		index[j+gap]= temp_in2
		if j <= gap then
		    exit
		end if
		j -= gap
	    end while
	    x[j] = tempi
	    index[j]= temp_in1
	end for
	if gap = 1 then
	     return {x,index}
	else
	     gap = floor(gap / 3) + 1
	end if
    end while
end function

global function ஢__ᠬ(sequence x)
-- Sort a sequence into ascending order. The elements can be atoms or 
-- sequences. The standard compare() routine is used to compare elements.
-- This sort algorithym is modified from the standard, euphorian one, and differs in that it
-- returns the index of the elements of the sorted sequence as well as the sorted sequence.
    integer gap, j, first, last
    object tempi, tempj,temp_in1,temp_in2
    sequence index

    index={}
    for z=1 to length(x) do
       index&={z}
    end for

    last = length(x)
    gap = floor(last / 3) + 1
    while 1 do
	first = gap + 1
	for i = first to last do
	    tempi = x[i]
	    temp_in1=index[i]
	    j = i - gap
	    while 1 do
		tempj = x[j]
		temp_in2=index[j]

		if compare(tempi, tempj) >= 0 then
		    j += gap
		    exit
		end if
		x[j+gap] = tempj
		index[j+gap]= temp_in2
		if j <= gap then
		    exit
		end if
		j -= gap
	    end while
	    x[j] = tempi
	    index[j]= temp_in1
	end for
	if gap = 1 then
	     return {x,index}
	else
	     gap = floor(gap / 3) + 1
	end if
    end while
end function


